Notice
Recent Posts
Recent Comments
Link
일 | 월 | 화 | 수 | 목 | 금 | 토 |
---|---|---|---|---|---|---|
1 | 2 | 3 | 4 | 5 | 6 | 7 |
8 | 9 | 10 | 11 | 12 | 13 | 14 |
15 | 16 | 17 | 18 | 19 | 20 | 21 |
22 | 23 | 24 | 25 | 26 | 27 | 28 |
29 | 30 | 31 |
Tags
- 2294
- DirectX11
- DeferredRendering
- GeeksForGeeks
- 언리얼엔진5
- C
- UE5
- 오블완
- baekjoon
- 줄 세우기
- 1563
- 팰린드롬 만들기
- Frustum
- IFileDialog
- RootMotion
- algorithm
- NRVO
- softeer
- Unreal Engine5
- 백준
- Programmers
- UnrealEngine4
- 프로그래머스
- winapi
- UnrealEngine5
- C++
- const
- directx
- RVO
- 티스토리챌린지
Archives
- Today
- Total
Game Develop
[Algorithm] Programmers :: 2차원 동전 뒤집기 본문
https://school.programmers.co.kr/learn/courses/30/lessons/131703
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
|
int answer = 0x3f3f3f3f;
vector<vector<int>> board;
vector<vector<int>> targetBoard;
int compareCol(int col)
{
int count = 0;
for (int i = 0; i < board.size(); ++i)
{
if (board[i][col] == targetBoard[i][col])
{
++count;
}
}
if (count == board.size()) return 0;
if (count == 0) return 1;
return -1;
}
void FlipRow(int r)
{
for (int i = 0; i < board[0].size(); ++i)
{
board[r][i] = !board[r][i];
}
}
void DFS(int row, int rowFlipCount)
{
if (row == board.size())
{
// 체크.
int count = 0;
for (int i = 0; i < board[0].size(); ++i)
{
int result = compareCol(i);
if (result == -1) return;
count += result;
}
answer = min(answer, count+rowFlipCount);
return;
}
DFS(row + 1, rowFlipCount);
FlipRow(row);
DFS(row + 1, rowFlipCount + 1);
FlipRow(row);
}
int solution(vector<vector<int>> beginning, vector<vector<int>> target)
{
board = beginning;
targetBoard = target;
DFS(0, 0);
if (answer == 0x3f3f3f3f) return -1;
return answer;
}
|
cs |
Lv3문제에는 그리디 + 탐색유형이 꽤 많은 것 같다.
이것도 이전문제와 굉장히 비슷한 느낌의 문제이다. 탐색을 시도하되, 필요한 부분만 우선적으로 탐색하는 것이다.
이번 문제같은 경우는 그냥 행을 뒤집,안뒤집 케이스를 탐색하면서 열을 전부 검사하면 된다.
열을 검사할 때 타겟과 전부같거나 전부다르면 타겟으로 만들 수 있다. (전부 다르면 뒤집으면 되니까)
단 일부분만 다를 경우는 타겟으로 만들 수 없기 때문에 그냥 그대로 해당케이스를 return시키면 된다.
뒤집,안뒤집는것만 따지기때문에 bit로 풀 수도 있다.
'Algorithm > Programmers' 카테고리의 다른 글
[Algorithm] Programmers :: 등대 (0) | 2023.08.31 |
---|---|
[Algorithm] Programmers :: 부대복귀 (0) | 2023.08.28 |
[Algorithm] Programmers :: 고고학 최고의 발견 (0) | 2023.08.24 |
[Algorithm] Programmers :: 파괴되지 않은 건물 (0) | 2023.08.23 |
[Algorithm] Programmers :: 카운트 다운 (0) | 2023.08.22 |